{{
This is the start of a program to control a sprinkler system.

By Steven and computer_guy

}}
CON
  MaxScheduleItems=100 'change this to whatever you want

  'pins that we are using for the clock
  inClk=4    'change these to whatever you are using
  inIO =5
  inCe =6

  rxPin=7
  txPin=8
  mode=0
  baudrate=9600

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000




OBJ
  eeprom : "Propeller Eeprom"
  clock  : "DS1302"
  text   : "TV_Text"
  ser    : "FullDuplexSerial"

VAR
  long schedule[MaxScheduleItems]
  byte NumScheduleItems

'Format for schedule items is
'byte day
'byte hours
'byte minutes
'byte control instruction
'Which comes to 1 long
  
PUB start|i,currentTime,checkTime
'to be finished at some stage
  'Just so that I can see what it is doing. You can comment it out if you want
  text.start(12)
  text.str(string("Hi!!"))

  'Setup the clock
  clock.init(inClk,inIO,inCe)
  clock.config

  ser.start(rxpin, txpin, mode, baudrate)

  text.str(string(13,"Finished setup"))

  'Insert a dummy item
  insertItem(newItem(1,23,24,start1))
  insertItem(newItem(1,23,40,stop1))
  
  'We need to check for serial input and check the time in here
  'If either occures we need to call the appropiate function
  'One of the methods from the serial will need to be setting the clocks

  repeat
    'get the time
    currentTime:=getTestTime  'Change this to getTime for the real thing
    'go through all the items in the schedule
    repeat i from 0 to NumScheduleItems-1
      'get item from the schedule and blank out the control instruction
      checkTime:=schedule[i]
      checkTime.byte[3]:=0
      'if the same do the instruction
      if currentTime==checkTime
        checkTime:=schedule[i]
        doInstruction(checkTime.byte[3])
      'should probable have a waitcnt in here to save some power
      'waitcnt(cnt)     'You can uncomment this if you want
    checkSerial

  'These two methods are use to save and get the schedule from the eeprom
PUB getSchedule 'We probably won't actuall need this method but it was easy to write it so here it is
  eeprom.VarRestore(@schedule[0],@schedule[NumScheduleItems-1])

PUB backupSchedule
  eeprom.VarBackup(@schedule[0],@schedule[NumScheduleItems-1])

PUB insertItem(item)
'This adds a schedule item to the list
  schedule[NumScheduleItems]:=item
  NumScheduleItems:=NumScheduleItems+1
  printSchedule

PUB newItem(day,hours,minutes,instruction):item
  'This returns a long which is in the right format
  'and turns the hours and minutes into BCD
  item.byte[0]:=day
  item.byte[1]:=(hours/10)<<4+hours//10
  item.byte[2]:=(minutes/10)<<4+minutes//10
  item.byte[3]:=instruction

PUB printTime(time)
  text.str(string(13,"Time "))
  text.hex(time.byte[1]>>4,1)
  text.hex(time.byte[1],1)
  text.out(":")
  text.hex(time.byte[2]>>4,1)
  text.hex(time.byte[2],1)

  text.str(string(",  Day "))
  case time.byte[0]
    0: text.str(string("Sunday"))
    1: text.str(string("Monday"))
    2: text.str(string("Tuesday"))
    3: text.str(string("Wednesday"))
    4: text.str(string("Thursday"))
    5: text.str(string("Friday"))
    6: text.str(string("Saturday"))

  text.str(string(", Code "))
  text.hex(time.byte[3],2) 

PUB printSchedule|i
  text.str(string(1,$B,2))
  repeat i from 0 to NumScheduleItems-1
    printTime(schedule[i])
CON
  'some suggested codes - this is just an enumeration so that we don't have to rember a whole heap
  'of numbers
  start1
  stop1
  
  start2
  stop2

  pin1=4
  pin2=5
  pin3=6
  pin4=7
  pin5=8
  pin6=9
  pin7=10
  pin8=11
  
PUB doInstruction(instruction)
  'This will turn on/off whatever pin or do whatever else we want to do
  'Could even hoopup one of the timers so that we could get a PWM output
  case instruction
    start1:
      outa[pin1]~
      text.str(string(13,"called code start1"))
    stop1:
      outa[1]~~

PUB getTime:time|temp
  clock.readDate(@temp,@temp,@temp,@time.byte[0])
  clock.readTime(@time.byte[1],@time.byte[2],@temp)

PUB getTestTime:time
  time:=newItem(1,23,24,0)

CON
  sendSchedule=%10101111     'I changed these so that they would be more different
  recieveItem=%0101000
  clearList=%10101010  

PUB checkSerial|temp
  temp:=ser.rxCheck
  case temp
    sendSchedule:
      sendDataSerial
    recieveItem:
      getItemSerial
    clearList:
      NumScheduleItems:=0

PUB getItemSerial
  insertItem(newItem(ser.rx,ser.rx,ser.rx,ser.rx))
  
PUB sendDataSerial|i,temp
  ser.tx(NumScheduleItems)'So that you know how many items there are
  repeat i from 0 to NumScheduleItems-1
    temp:=schedule[i]
    ser.tx(temp.byte[0])
    ser.tx(temp.byte[1])
    ser.tx(temp.byte[2])
    ser.tx(temp.byte[3])     